\section{Architecture}

\subsection{Technologies}

\begin{itemize}
		\item \textbf{Frontend:} React - A JavaScript library for building user interfaces
		\item \textbf{Backend:} Node.js with Express.js as webframework
		\item \textbf{Websocket:} ws - a Node.js WebSocket library
		\item \textbf{Load Balancer:} Nginx
		\item \textbf{Database:} MongoDB (NoSQL) with Mongoose as a MongoDB object modeling tool
		\item \textbf{Dockerized}
\end{itemize}


\subsection{Application Architecture}

The application is based on a client server system with a client-side rendered frontend and websocket as a means of synchronization with the  backend server.
\vspace{1cm}
\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{application-architecture}
  \caption{Application Architecutre}
\end{figure}
\vspace{1cm}
\begin{figure}[h]
	\center
	\includegraphics[width=0.9\textwidth]{deployment-architecture}
	\caption{Deployment Architecture}
\end{figure}

\pagebreak


\subsection{Sequence Diagram}

To synchronize the board across several users, we developed our own protocol for websocket. It features a get message to get the initial state of the board and an update message that allows to change the board.
\vspace{1cm}
\begin{figure}[h!]
  \center
  \includegraphics[width=0.9\textwidth]{sequencediagram}
  \caption{Sequence Diagram}
\end{figure}
